# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['GoogleCloudCredentialArgs', 'GoogleCloudCredential']

@pulumi.input_type
class GoogleCloudCredentialArgs:
    def __init__(__self__, *,
                 source_file: pulumi.Input[str],
                 name: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a GoogleCloudCredential resource.
        :param pulumi.Input[str] source_file: The source file of the Google Cloud Credential.
        :param pulumi.Input[str] name: The name of the Google Cloud Credential.
        """
        pulumi.set(__self__, "source_file", source_file)
        if name is not None:
            pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter(name="sourceFile")
    def source_file(self) -> pulumi.Input[str]:
        """
        The source file of the Google Cloud Credential.
        """
        return pulumi.get(self, "source_file")

    @source_file.setter
    def source_file(self, value: pulumi.Input[str]):
        pulumi.set(self, "source_file", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the Google Cloud Credential.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)


@pulumi.input_type
class _GoogleCloudCredentialState:
    def __init__(__self__, *,
                 name: Optional[pulumi.Input[str]] = None,
                 source_file: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering GoogleCloudCredential resources.
        :param pulumi.Input[str] name: The name of the Google Cloud Credential.
        :param pulumi.Input[str] source_file: The source file of the Google Cloud Credential.
        """
        if name is not None:
            pulumi.set(__self__, "name", name)
        if source_file is not None:
            pulumi.set(__self__, "source_file", source_file)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the Google Cloud Credential.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="sourceFile")
    def source_file(self) -> Optional[pulumi.Input[str]]:
        """
        The source file of the Google Cloud Credential.
        """
        return pulumi.get(self, "source_file")

    @source_file.setter
    def source_file(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "source_file", value)


class GoogleCloudCredential(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 source_file: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Api Token Credential

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] name: The name of the Google Cloud Credential.
        :param pulumi.Input[str] source_file: The source file of the Google Cloud Credential.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: GoogleCloudCredentialArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Api Token Credential

        :param str resource_name: The name of the resource.
        :param GoogleCloudCredentialArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(GoogleCloudCredentialArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 source_file: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = GoogleCloudCredentialArgs.__new__(GoogleCloudCredentialArgs)

            __props__.__dict__["name"] = name
            if source_file is None and not opts.urn:
                raise TypeError("Missing required property 'source_file'")
            __props__.__dict__["source_file"] = source_file
        super(GoogleCloudCredential, __self__).__init__(
            'datarobot:index/googleCloudCredential:GoogleCloudCredential',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            name: Optional[pulumi.Input[str]] = None,
            source_file: Optional[pulumi.Input[str]] = None) -> 'GoogleCloudCredential':
        """
        Get an existing GoogleCloudCredential resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] name: The name of the Google Cloud Credential.
        :param pulumi.Input[str] source_file: The source file of the Google Cloud Credential.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _GoogleCloudCredentialState.__new__(_GoogleCloudCredentialState)

        __props__.__dict__["name"] = name
        __props__.__dict__["source_file"] = source_file
        return GoogleCloudCredential(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The name of the Google Cloud Credential.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="sourceFile")
    def source_file(self) -> pulumi.Output[str]:
        """
        The source file of the Google Cloud Credential.
        """
        return pulumi.get(self, "source_file")

